(load "syntax.scm")
(load "meval.scm")
(define *meval-warn-define* #t)
(load "environment.scm")

(define (make-procedure parameters body env)
  (list 'procedure parameters body env 0))      ;; CHANGED
(define (compound-procedure? exp)
  (tagged-list? exp 'procedure))
(define (procedure-parameters p) (second p))
(define (procedure-body p) (third p))
(define (procedure-environment p) (fourth p))
(define (procedure-call-count p) (fifth p))     ;; NEW
(define (procedure-call-count-inc! p)           ;; NEW
  (set-car! (cddddr p) (inc (car (cddddr p))))) ;; NEW

(define (primitive-procedures)
  (list (list 'car car)           (list 'cdr cdr)
        (list 'cons cons)         (list 'set-car! set-car!)
	(list 'set-cdr! set-cdr!) (list 'null? null?)
        (list '+ +) (list '- -)  (list '< <)
        (list '> >) (list '= =)  (list 'display display)
	(list 'not not)
	(list 'times-called procedure-call-count) ;; NEW
	(list 'eq? eq?)                           ;; NEW
        ))

(define (m-apply procedure arguments)
  (cond ((primitive-procedure? procedure)
	 (apply-primitive-procedure procedure arguments))
	((compound-procedure? procedure)
	 (eval-sequence
	  (procedure-body procedure)
	  (extend-environment (procedure-parameters procedure)
			      arguments
			      (procedure-environment procedure)))
	 (procedure-call-count-inc! procedure)) ;; NEW
	(else (error "Unknown procedure type -- APPLY" procedure))))

(refresh-global-environment)

(m-eval '(define map (lambda (f l)
		       (if (eq? l #f)
			   #f
			   (cons (f (car l)) (map f (cdr l))))))
	the-global-environment)

(m-eval '(define (sqr x) x) the-global-environment)
(m-eval '(times-called sqr) the-global-environment)
(m-eval '(sqr (sqr 4)) the-global-environment)
(m-eval '(times-called sqr) the-global-environment)
(m-eval '(map sqr '(1 2 3 4)) the-global-environment)
(m-eval '(times-called sqr) the-global-environment)
